org.codehaus.groovy.ast.expr

## Class MethodCallExpression

- java.lang.Object
- - org.codehaus.groovy.ast.ASTNode
  - - org.codehaus.groovy.ast.AnnotatedNode
    - - org.codehaus.groovy.ast.expr.Expression
      - - org.codehaus.groovy.ast.expr.MethodCallExpression

    public class MethodCallExpression
    extends Expression

A method call on an object or class

Version:
  $Revision: 21434 $
Author:
  James Strachan

### Field Summary

Fields
`static Expression` `NO_ARGUMENTS`

### Constructor Summary

Constructors
Constructor and Description
`MethodCallExpression(Expression objectExpression, Expression method, Expression arguments)`
`MethodCallExpression(Expression objectExpression, String method, Expression arguments)`

### Method Summary

Methods
`Expression` `getArguments()`
`GenericsType[]` `getGenericsTypes()`
`MetaMethod` `getMetaMethod()` Deprecated.
`Expression` `getMethod()`
`String` `getMethodAsString()` This method returns the method name as String if it is no dynamic calculated method name, but a constant.
`MethodNode` `getMethodTarget()`
`Expression` `getObjectExpression()`
`String` `getText()`
`boolean` `isImplicitThis()`
`boolean` `isSafe()`
`boolean` `isSpreadSafe()`
`boolean` `isUsingGenerics()`
`void` `setArguments(Expression arguments)`
`void` `setGenericsTypes(GenericsType[] genericsTypes)`
`void` `setImplicitThis(boolean implicitThis)`
`void` `setMetaMethod(MetaMethod mmeth)` Deprecated.
`void` `setMethod(Expression method)`
`void` `setMethodTarget(MethodNode mn)`
`void` `setObjectExpression(Expression objectExpression)`
`void` `setSafe(boolean safe)`
`void` `setSpreadSafe(boolean value)`
`String` `toString()`
`Expression` `transformExpression(ExpressionTransformer transformer)` Return a copy of the expression calling the transformer on any nested expressions
`void` `visit(GroovyCodeVisitor visitor)`

### Methods inherited from class org.codehaus.groovy.ast.expr.Expression

`getType, setType, transformExpressions, transformExpressions`

### Methods inherited from class org.codehaus.groovy.ast.AnnotatedNode

`addAnnotation, addAnnotations, getAnnotations, getAnnotations, getDeclaringClass, hasNoRealSourcePosition, isSynthetic, setDeclaringClass, setHasNoRealSourcePosition, setSynthetic`

### Methods inherited from class org.codehaus.groovy.ast.ASTNode

`copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getNodeMetaData, removeNodeMetaData, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setNodeMetaData, setSourcePosition`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### NO_ARGUMENTS

    public static final Expression NO_ARGUMENTS

### Constructor Detail

#### MethodCallExpression

    public MethodCallExpression(Expression objectExpression,
                        String method,
                        Expression arguments)

#### MethodCallExpression

    public MethodCallExpression(Expression objectExpression,
                        Expression method,
                        Expression arguments)

### Method Detail

#### getMetaMethod

    public MetaMethod getMetaMethod()

Deprecated.

#### visit

    public void visit(GroovyCodeVisitor visitor)

Overrides:
  `visit` in class `ASTNode`

#### transformExpression

    public Expression transformExpression(ExpressionTransformer transformer)

Description copied from class: `Expression`
Return a copy of the expression calling the transformer on any nested expressions

Specified by:
  `transformExpression` in class `Expression`

#### getArguments

    public Expression getArguments()

#### setArguments

    public void setArguments(Expression arguments)

#### getMethod

    public Expression getMethod()

#### setMethod

    public void setMethod(Expression method)

#### getMethodAsString

    public String getMethodAsString()

This method returns the method name as String if it is no dynamic calculated method name, but a constant.

#### setObjectExpression

    public void setObjectExpression(Expression objectExpression)

#### getObjectExpression

    public Expression getObjectExpression()

#### getText

    public String getText()

Overrides:
  `getText` in class `ASTNode`

#### isSafe

    public boolean isSafe()

Returns:
  is this a safe method call, i.e. if true then if the source object is null then this method call will return null rather than throwing a null pointer exception

#### setSafe

    public void setSafe(boolean safe)

#### isSpreadSafe

    public boolean isSpreadSafe()

#### setSpreadSafe

    public void setSpreadSafe(boolean value)

#### isImplicitThis

    public boolean isImplicitThis()

Returns:
  true if no object expression was specified otherwise if some expression was specified for the object on which to evaluate the method then return false

#### setImplicitThis

    public void setImplicitThis(boolean implicitThis)

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

#### setMetaMethod

    public void setMetaMethod(MetaMethod mmeth)

Deprecated.

#### getGenericsTypes

    public GenericsType[] getGenericsTypes()

#### setGenericsTypes

    public void setGenericsTypes(GenericsType[] genericsTypes)

#### isUsingGenerics

    public boolean isUsingGenerics()

#### setMethodTarget

    public void setMethodTarget(MethodNode mn)

#### getMethodTarget

    public MethodNode getMethodTarget()